## kissfft-dmo 131.1.0

=== debian/changelog ===
kissfft-dmo (131.1.0-dmo2) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 18 Mar 2024 08:39:08 +0100

kissfft-dmo (131.1.0-dmo1) unstable; urgency=medium

  * Upload to my repository.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 28 Feb 2021 08:40:46 +0100

kissfft (131.1.0-1) unstable; urgency=medium

  * Change watchfile to tagged releases
  * Drop unnecessary patches
  * New upstream version 131.1.0
  * Reflect file name changes in tagged release (and add Breaks against the
    packages that links to it).

 -- Vasyl Gello <vasek.gello@gmail.com>  Tue, 16 Feb 2021 13:08:39 +0000

kissfft (131+git20201106.cc862cb-2) unstable; urgency=medium

  * Team upload.
  * Tentative fix for FTBFS on kfreebsd.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 21 Jan 2021 22:12:54 +0100

kissfft (131+git20201106.cc862cb-1) unstable; urgency=medium

  * Initial upload (Closes: #950180)

 -- Vasyl Gello <vasek.gello@gmail.com>  Fri, 08 Jan 2021 12:04:27 +0000
