=== debian/control ===
Source: kissfft-dmo
Priority: optional
Section: libs
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/mborgerding/kissfft
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), cmake, libfftw3-dev, libpng-dev, pkgconf,
 python3-numpy

Package: libkissfft-float131
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: kissfft-tools (<< 131.1.0-1~), kodi-visualization-pictureit (<< 3.4.0+ds1-3~),
 kodi-visualization-shadertoy (<< 2.3.0+ds1-3~)
Description: Mixed-radix Fast Fourier Transform library
 There are many great fft libraries already around. Kiss FFT is not trying
 to be better than any of them. It only attempts to be a reasonably
 efficient, moderately useful FFT that can use fixed or floating data types
 and can be incorporated into someone's C program in a few minutes with
 trivial licensing.

Package: kissfft-tools
Section: math
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Mixed-radix Fast Fourier Transform library (CLI tools)
 There are many great fft libraries already around. Kiss FFT is not trying
 to be better than any of them. It only attempts to be a reasonably
 efficient, moderately useful FFT that can use fixed or floating data types
 and can be incorporated into someone's C program in a few minutes with
 trivial licensing.
 .
 This package installs CLI tools by kissfft.

Package: libkissfft-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkissfft-float131 (= ${binary:Version}), ${misc:Depends}
Description: Mixed-radix Fast Fourier Transform library (development tools)
 There are many great fft libraries already around. Kiss FFT is not trying
 to be better than any of them. It only attempts to be a reasonably
 efficient, moderately useful FFT that can use fixed or floating data types
 and can be incorporated into someone's C program in a few minutes with
 trivial licensing.
 .
 This package installs only files needed for development: header, libraries.
