## kissfft-dmo 131.2.0

=== debian/changelog ===
kissfft-dmo (131.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 23 Oct 2025 08:51:12 +0200

kissfft-dmo (131.1.0-dmo2+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 31 Oct 2024 09:25:26 +0100
