=== debian/control ===
--- 
+++ 
@@ -4,17 +4,16 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://github.com/mborgerding/kissfft
-Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13), cmake, libfftw3-dev, libpng-dev, pkgconf,
- python3-numpy
+ python3-numpy, ninja-build, quilt,
 
 Package: libkissfft-float131
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends},
 Breaks: kissfft-tools (<< 131.1.0-1~), kodi-visualization-pictureit (<< 3.4.0+ds1-3~),
- kodi-visualization-shadertoy (<< 2.3.0+ds1-3~)
+ kodi-visualization-shadertoy (<< 2.3.0+ds1-3~),
 Description: Mixed-radix Fast Fourier Transform library
  There are many great fft libraries already around. Kiss FFT is not trying
  to be better than any of them. It only attempts to be a reasonably
@@ -25,7 +24,7 @@
 Package: kissfft-tools
 Section: math
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends},
 Description: Mixed-radix Fast Fourier Transform library (CLI tools)
  There are many great fft libraries already around. Kiss FFT is not trying
  to be better than any of them. It only attempts to be a reasonably
@@ -39,7 +38,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libkissfft-float131 (= ${binary:Version}), ${misc:Depends}
+Depends: libkissfft-float131 (= ${binary:Version}), ${misc:Depends},
 Description: Mixed-radix Fast Fourier Transform library (development tools)
  There are many great fft libraries already around. Kiss FFT is not trying
  to be better than any of them. It only attempts to be a reasonably
