=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-D CMAKE_BUILD_TYPE=RelWithDebInfoWithDebInfo \
	-D BUILD_SHARED_LIBS=ON \
	-D USE_LTO=1 \
	${CONFIGURE_OPTS}
