=== debian/watch ===
version=4

https://github.com/mborgerding/kissfft/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
